﻿
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Backup.Model;

namespace Backup.FileOperations {
    internal class CopyDirectory {

        public static DateTime LastBackup = new DateTime(1900, 1, 1);
        public static List<String> negativeExt = new List<string>();

        private String source;
        private String dest;

        public List<ModelCopy> listCopy = new List<ModelCopy>();

        public CopyDirectory(String source, String dest) {
            if (source.EndsWith("\\"))
                this.source = source;
            else
                this.source = source + "\\";

            if (dest.EndsWith("\\"))
                this.dest = dest;
            else
                this.dest = dest + "\\";
        }

        private bool isExtOkay(FileInfo file) {
            if (negativeExt.Count > 0) {
                String path, name, ext;
                Basis.splitFilename(file.FullName, out path, out name, out ext);
                ext = ext.ToLower();
                foreach (String filedir in negativeExt) {
                    if (ext.Equals(filedir)) return false;
                }
                return true;
            }
            else {
                return true;
            }
        }

        private void copyDirectory(String source, String dest) {
            DirectoryInfo mainDir = new DirectoryInfo(source);
            DirectoryInfo[] dirs = mainDir.GetDirectories();
            FileInfo[] files = mainDir.GetFiles();

            Directory.CreateDirectory(dest);

            // copy  source\*.*  nach dest\*.*
            foreach (FileInfo file in files) {
                if (LastBackup < file.LastWriteTime && isExtOkay(file)) {
                    listCopy.Add(new ModelCopy(file.FullName, dest + file.Name, file.Length));
                }
                // File.Copy(file.FullName, dest + file.Name, true);                
            }

            foreach (DirectoryInfo dir in dirs) {
                copyDirectory(dir.FullName + "\\", dest + dir.Name + "\\");
            }
        }  // copyDirectory


        // setValue(i);
        public bool StartCopyFiles1() {
            try {
                DirectoryInfo mainDir = new DirectoryInfo(source);
                DirectoryInfo[] dirs = mainDir.GetDirectories();
                FileInfo[] files = mainDir.GetFiles();

                Directory.CreateDirectory(dest);  // should create in deleteKataster

                // copy  source\*.*  nach dest\*.*
                foreach (FileInfo file in files) {
                    if (LastBackup < file.LastWriteTime && isExtOkay(file)) {
                        listCopy.Add(new ModelCopy(file.FullName, dest + file.Name, file.Length));
                    }
                    // File.Copy(file.FullName, dest + file.Name, true);
                }

                foreach (DirectoryInfo dir in dirs) {
                    copyDirectory(dir.FullName + "\\", dest + dir.Name + "\\");
                }
                return true;
            }
            catch (Exception e) {
                Basis.ErrorMsg("Das Zielverzeichnis konnte nicht erstellet werden\r\n" + e.ToString(), "Fehler");
                return false;
            }
        }  // StartCopyFiles

    }
}
